/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_config.c 2106 2011-06-21 13:46:09Z ertl-honda $
 */

/*
 *		ץå¸⥸塼SH34ѡ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"

/*
 *  CPUåե饰¸Τѿ
 */
volatile bool_t		lock_flag;		/* CPUåե饰ͤݻѿ */
volatile uint8_t	saved_iipm;		/* ͥ٥ޥ¸ѿ */

/*
 *  ƳֹIPRξơ֥
 *  Ƥϡץå˰ۤʤΤᡤ
 *  ץåե
 */
const IPR_INFO ipr_info_tbl[TNUM_INH] = {
    IPR_INFO_TBL_DATA 
};

/*
 *  ٥١¸
 */
static void *saved_vbr;

/*
 *  ͥΥ٥١
 */
extern void base_vec(void);

/*
 *  ץå¸ν
 */
void
prc_initialize(void)
{
    /*
     *  CPUåե饰¸Τѿν
     */
    lock_flag = true;
    saved_iipm = IIPM_ENAALL;
    
    /*
     *  ߥȥν
     *  ץå 
     */
    init_irc();

    /*
     *  ٥١쥸ν
     */
    saved_vbr = current_vbr();
    set_vbr(base_vec);
}

/*
 *  ץå¸νλ
 */
void
prc_terminate(void)
{
    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

    /*
     *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
     *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
     *  Ǥ롥
     */
    if (fp != 0) {
        (*fp)();
    }

    set_vbr(saved_vbr);
}

/*
 *  ׵饤°
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
    assert(VALID_INTNO_CFGINT(intno));
    assert(-15 <= intpri && intpri <= TMAX_INTPRI);

    /* 
     *  öߤػߤ
     */    
    (void)x_disable_int(intno);

    /*
     *  ٥ȥꥬ/åȥꥬ
     *  IRQΤߥݡȤ
     */
    if(INTNO_IRQ(intno) != 0U){
        uint16_t icr1_val = sil_rew_mem((void*)ICR1);
        uint16_t offset   = INTNO_IRQ_OFFSET(intno) * 2U;

        icr1_val &=  ~(0x03U << offset);
        
        if((intatr & TA_POSEDGE) != 0U) {
            /*
             *  ݥƥ֥å
             */
            icr1_val |= IRQ_POSEDGE << offset;            
        }else if((intatr & TA_NEGEDGE) != 0U) {
            /*
             *  ͥƥ֥å
             */
            icr1_val |= IRQ_NEGEDGE << offset;                        
        }else {
            /*
             *  ٥ȥꥬ
             */
            icr1_val |= IRQ_LOWLEVEL << offset;
        }
        
        sil_wrw_mem((void*)ICR1, icr1_val);
    }

    /*
     *  ׵ޥ(ɬפʾ)
     *  Ʊ˳ͥ٤⥻åȤ
     */
    if ((intatr & TA_ENAINT) != 0U) {
        (void) x_enable_int(intno);
    }    
}


#ifndef OMIT_DEFAULT_EXC_HANDLER
/*
 *  Trapaʳ㳰ϿƤʤ㳰ȯȸƤӽФ
 */
void
default_exc_handler(void *p_excinf)
{
    uint32_t expevt = *(((uint32_t*)p_excinf) + P_EXCINF_EXC_OFFSET_EXPEVT);
    uint32_t spc    = *(((uint32_t*)p_excinf) + P_EXCINF_EXC_OFFSET_SPC);
    uint32_t ssr    = *(((uint32_t*)p_excinf) + P_EXCINF_EXC_OFFSET_SSR);
    uint32_t pr     = *(((uint32_t*)p_excinf) + P_EXCINF_EXC_OFFSET_PR);
    
    syslog(LOG_EMERG, "Unregistered Expevt error occurs.");
    syslog(LOG_EMERG, "Expevt = %08x SPC = %08x SR = %08x PR=%08X",
           expevt, spc, ssr, pr);
    target_exit();
}
#endif /* OMIT_DEFAULT_EXC_HANDLER */

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 *  ̤Ͽγߤȯ˸ƤӽФ
 */
void
default_int_handler(void *p_excinf)
{
    uint32_t spc     = *(((uint32_t*)p_excinf) + P_EXCINF_INT_OFFSET_SPC);
    uint32_t ssr     = *(((uint32_t*)p_excinf) + P_EXCINF_INT_OFFSET_SSR);
    uint32_t pr      = *(((uint32_t*)p_excinf) + P_EXCINF_INT_OFFSET_PR);
    uint32_t intevt  = sil_rew_mem((void*)INTEVT);
#ifdef USE_INTEVT2    
    uint32_t intevt2 = sil_rew_mem((void*)INTEVT2);
#endif /* USE_INTEVT2 */      
    syslog(LOG_EMERG, "Unregistered Interrupt occurs.");
#ifdef USE_INTEVT2    
    syslog(LOG_EMERG, "INTEVT = %08x INTEVT2 = %08x SPC = %08x SR = %08x PR = %08x ",
           intevt, intevt2, spc, ssr, pr);
#else
    syslog(LOG_EMERG, "INTEVT = %08x SPC = %08x SR = %08x PR = %08x ",
           intevt, spc, ssr, pr);    
#endif /* USE_INTEVT2 */      
    target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */
